import sys
import sha
import RDF

print_data = 1

def getnick(subjectnode,m):
    """Get a nickname from a subject RDF.Node()"""
    foaf = RDF.NS("http://xmlns.com/foaf/0.1/")
    statements = m.find_statements(RDF.Statement(subjectnode, foaf.nick, None))
    nickstatement = statements.current()
    return nickstatement.object.literal_value['string']
    return "null"

def getstorage():
    return RDF.MemoryStorage()

def main(args):
    if len(args) < 3:
        print """Usage: %s type value
        type   -  sha or ID -- defines whether to search on sha1sum or
                  jim:foafnautID
        value  -  value being searched for. possibly a bnode identifier,
                  URI, or sha1sum."""%args[0]
        return    
    # Who to query for
    type = args[1]
    sha1 = args[2]

    print type, sha1
    # Init
    if len(args) > 3: 
        m = args[3]
    else: 
        s = getstorage()
        m = RDF.Model(s)
    p = RDF.Parser()
    foaf = RDF.NS("http://xmlns.com/foaf/0.1/")
    
    # Load data -- if you are loading from an existing Store, this is unneeded.
    
    # Find the RDF.Node that the person is
    try:
        if type == "sha":
            statements = m.find_statements(RDF.Statement(None, foaf.mbox_sha1sum, RDF.Node(sha1)))
            i = statements.current()
            person = i.subject
        elif type == "ID":
            if "://" in sha1: # This is a really crappy way of checking it. Should I even check it? Who knows.
                person = RDF.Node(RDF.Uri(sha1))
            elif sha1.startswith("r1"):
                person = RDF.Node(blank=sha1)
            else:
                raise "WrongTypeException", "ID doesn't seem to be a URI or a bnode."
        else:
            raise "InvalidArgumentsException"
        if person.is_resource():
           id = sha.new(str(person.uri)).hexdigest() 
        elif person.is_blank():
           id = sha.new(str(person.blank_identifier)).hexdigest()
        f = open("cache/%s" % id, "w")
        
        # Start printing information.
        f.write("""<rdf:RDF xmlns:img="http://jibbering.com/2002/3/svg/#" xmlns:jim="http://jibbering.com/foaf/jim.rdf#" xmlns:wn="http://xmlns.com/wordnet/1.6/" xmlns:foaf="http://xmlns.com/foaf/0.1/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:an="http://rdf.desire.org/vocab/recommend.rdf#" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:geo="http://www.w3.org/2003/01/geo/wgs84_pos#" xmlns:rdfs="http://www.w3.org/2000/01/rdf-schema#">\n""")
        if print_data: print """<rdf:RDF xmlns:img="http://jibbering.com/2002/3/svg/#" xmlns:jim="http://jibbering.com/foaf/jim.rdf#" xmlns:wn="http://xmlns.com/wordnet/1.6/" xmlns:foaf="http://xmlns.com/foaf/0.1/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:an="http://rdf.desire.org/vocab/recommend.rdf#" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:geo="http://www.w3.org/2003/01/geo/wgs84_pos#" xmlns:rdfs="http://www.w3.org/2000/01/rdf-schema#">"""
        if print_data: print """<foaf:Person>"""
        f.write("""<foaf:Person>\n""")
        
        f.write("<jim:foafnautID>%s</jim:foafnautID>"%id)
        if print_data: print "<jim:foafnautID>%s</jim:foafnautID>"%id
        for i in m.find_statements(RDF.Statement(person, foaf.name, None)):
            f.write("<foaf:name>%s</foaf:name>\n"%i.object.literal_value['string'])
            if print_data: print "<foaf:name>%s</foaf:name>"%i.object.literal_value['string']
        for i in m.find_statements(RDF.Statement(person, foaf.nick, None)):
            f.write("<foaf:nick>%s</foaf:nick>\n"%i.object.literal_value['string'])
            if print_data: print "<foaf:nick>%s</foaf:nick>"%i.object.literal_value['string']
        for i in m.find_statements(RDF.Statement(person, foaf.homepage, None)):
            if (i.object.is_resource()):
                if print_data: print "<foaf:homepage rdf:resource='%s' />\n" % i.object.uri
        for i in m.find_statements(RDF.Statement(person, foaf.depiction, None)):
            if (i.object.is_resource()):
                f.write("""<foaf:depiction rdf:resource="%s" />\n""" % i.object.uri)
                if print_data: print """<foaf:depiction rdf:resource="%s" />""" % i.object.uri
        for i in m.find_statements(RDF.Statement(person, foaf.knows, None)):
            nick = getnick(i.object,m)
            if i.object.is_blank():
                f.write("<foaf:knows rdf:nodeID='%s' jim:foafnautID='%s' foaf:nick='%s' />\n" % (i.object.blank_identifier, sha.new(str(i.object.blank_identifier)).hexdigest(),nick))
                if print_data: print "<foaf:knows rdf:nodeID='%s' jim:foafnautID='%s' foaf:nick='%s' />" % (i.object.blank_identifier, sha.new(str(i.object.blank_identifier)).hexdigest(),nick)
            elif i.object.is_resource():
                f.write("<foaf:knows rdf:resource='%s' jim:foafnautID='%s' foaf:nick='%s' />\n" % (i.object.uri,sha.new(str(i.object.uri)).hexdigest(),nick))
                if print_data: print "<foaf:knows rdf:resource='%s' jim:foafnautID='%s' foaf:nick='%s' />" % (i.object.uri,sha.new(str(i.object.uri)).hexdigest(),nick)
                 
        for i in m.find_statements(RDF.Statement(None, foaf.knows, person)):
            nick = getnick(i.subject,m)
            if i.subject.is_blank():
                f.write("""<jim:isKnownBy jim:foafnautID="%s" foaf:nick="%s" />\n""" % (sha.new(str(i.subject.blank_identifier)).hexdigest(), nick))
                if print_data: print """<jim:isKnownBy jim:foafnautID="%s" foaf:nick="%s" />""" % (sha.new(str(i.subject.blank_identifier)).hexdigest(), nick)
            elif i.subject.is_resource():
                f.write("""<jim:isKnownBy jim:foafnautID="%s" foaf:nick="%s" />\n""" % (sha.new(str(i.subject.uri)).hexdigest(), nick))
                if print_data: print """<jim:isKnownBy jim:foafnautID="%s" foaf:nick="%s" />""" % (sha.new(str(i.subject.uri)).hexdigest(), nick)
            
        f.write("</foaf:Person></rdf:RDF>")
        if print_data: print "</foaf:Person></rdf:RDF>"
    except Exception, E:
        print E
if __name__ == "__main__":
    main(sys.argv)
